//============================================================================
//	axpad03s.pas
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	V1.00 1998/08/07
//
//============================================================================

unit axpad03s;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs
  ,axpad03w, StdCtrls;

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
  private
		procedure ResultMessage(strbuf: String);
		procedure ErrorMessage(wLogSocket: Word);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

//---------------------------------------------------------------------------
// Cienbj
//---------------------------------------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
var
	strbuf:	 			String;
	dwDLLVer, 		dwDrvVer: DWord;	// DLLCDrivero[W
	bResult:			Boolean;					// 
	wLogSocket:		Word;							// foCXi[
	ri:						TAD03RESOURCE;		// \[X
	md:						TAD03MODE;				// TvO[h
  cwNumData:		DWord;						// TvO
  dwStatus:			DWord;						// TvOXe[^X
	awData:				TAD03SMPLBUFF;		// TvOf[^obt@
  i:						Word;							// [vpϐ
begin
	//---------------------------------------------------------------------------
	// DLL̎gp錾
	//---------------------------------------------------------------------------
	if Ad03wDllOpen()=False then ErrorMessage(AD03_SOCKET_AUTO);
	ResultMessage('DLL[h܂B');
	//---------------------------------------------------------------------------
	// DLL,VxD̃o[Wԍ擾
	//---------------------------------------------------------------------------
	if Ad03wGetVersion(dwDLLVer, dwDrvVer)=False then ErrorMessage(AD03_SOCKET_AUTO);
	strbuf := Format('o[Wԍ擾'#10 +
									 'DLL Version: %08xH'#10 +
									 'Drv Version: %08xH',[dwDLLVer, dwDrvVer]);
	ResultMessage(strbuf);
	//---------------------------------------------------------------------------
	// foCX̎gp錾
	//---------------------------------------------------------------------------
	wLogSocket := AD03_SOCKET_AUTO;			// gp̃foCXT܂B
	bResult := Ad03wCreate(wLogSocket,	// ꍇA̎̃foCXi[܂B
  											 0,						// Oe튄荞݂𑗂EBhEnhigpȂj
												 0);					// ObZ[Wx[XligpȂj
	if bResult=False then ErrorMessage(AD03_SOCKET_AUTO);
	strbuf := Format('foCX̎gp錾'#10#10 +
									 'LogSocket: %2d', [wLogSocket]);
	ResultMessage(strbuf);
	//---------------------------------------------------------------------------
	// \[X擾
	//---------------------------------------------------------------------------
	if Ad03wGetResource(wLogSocket, @ri)=False then ErrorMessage(wLogSocket);
	strbuf := Format('\[X擾'#10 +
									 'NumPorts: %2d'#10 +
									 'IO Address: %04xH - %04xH'#10,
										[ri.dwIOPortLength[1],ri.dwIOPortBase[1],
										 ri.dwIOPortBase[1] + ri.dwIOPortLength[1] - 1]);
	ResultMessage(strbuf);
	//---------------------------------------------------------------------------
	// TvO[h̐ݒ
	//---------------------------------------------------------------------------
	md.dwTrigMode 		:= 0;		// Trigger mode
	md.dwSampleTime 	:= 1;		// Sampling time
	md.dwTrigSource 	:= 0;		// Trigger Source
	md.dwTrigSlope 		:= 0;		// Trigger Slope
	md.dwTrigLevel 		:= 0;		// Trigger Level
	md.dwTrigPosition := 20;	// Trigger Position
	md.dwTrigDelay 		:= 0;		// Trigger Delay time
	md.dwTrigHoldOff 	:= 0;		// Trigger HoldOff time

	if Ad03wSetMode(wLogSocket,@md)=False then ErrorMessage(wLogSocket);
  strbuf := Format('TvO[h̐ݒ'#10 +
                   'gK[h=%d'#10 +
                   'TvO^C=%d'#10 +
                   'gK\[X=%d'#10 +
                   'gKX[v=%d'#10 +
                   'gKx=%d'#10 +
                   'gK|WV=%d'#10 +
                   'gKfBC=%d'#10 +
                   'gKgnkcnee=%d'#10,
									 [md.dwTrigMode,md.dwSampleTime,md.dwTrigSource,md.dwTrigSlope,
									  md.dwTrigLevel,md.dwTrigPosition,md.dwTrigDelay,md.dwTrigHoldOff]);
	ResultMessage(strbuf);
	//---------------------------------------------------------------------------
	// TvOJn
	//---------------------------------------------------------------------------
	if Ad03wStartSampling(wLogSocket)=False then ErrorMessage(wLogSocket);
	ResultMessage('TvOJn');
	//---------------------------------------------------------------------------
	// TvOEXe[^X̎擾
	//---------------------------------------------------------------------------
	if Ad03wGetSamplingStatus(wLogSocket,cwNumData,dwStatus)=False then ErrorMessage(wLogSocket);
	strbuf := Format('TvOEXe[^X擾'#10 +
									 'f[^=%d'#10 +
									 'Xe[^X=%x',[cwNumData,dwStatus]);
	ResultMessage(strbuf);
	//---------------------------------------------------------------------------
	// TvOς݃f[^̎擾
	//---------------------------------------------------------------------------
	if Ad03wGetData(wLogSocket,cwNumData,@awData)=False then ErrorMessage(wLogSocket);
	strbuf := '';
	for i:=1 to 50 do begin		// SĂް͕\łȂ̂50\
 		strbuf := strbuf + Format('%.02d:%.2xH  ', [i, awData[i]]);
		if i mod 4 = 0 then	strbuf := strbuf + #10;
	end;
	ResultMessage(strbuf);
	//---------------------------------------------------------------------------
	// TvO~(ʏ͎gp܂)
	//---------------------------------------------------------------------------
	if Ad03wStopSampling(wLogSocket)=False then ErrorMessage(wLogSocket);
	ResultMessage('TvO~');
	//---------------------------------------------------------------------------
	// foCXJ
	//---------------------------------------------------------------------------
	if Ad03wClose(wLogSocket)=False then ErrorMessage(wLogSocket);
	ResultMessage('foCXJ');
	//---------------------------------------------------------------------------
	// axpad03.dll ̎gpJ
	//---------------------------------------------------------------------------
	if Ad03wDllClose()=False then begin
		Application.MessageBox(PChar('DLL̃A[hɎs܂B'), 'AXP-AD03', MB_OK + MB_ICONSTOP);
		Halt(1);
	end;
	ResultMessage('DLLA[h܂B');
  Halt(0);
end;
//---------------------------------------------------------------------------
// ʂ\
//---------------------------------------------------------------------------
procedure TForm1.ResultMessage(strbuf: String);
begin
	Application.MessageBox(PChar(strbuf), 'AXP-AD03', MB_OK + MB_ICONINFORMATION);
end;
//---------------------------------------------------------------------------
// G[bZ[W\
//---------------------------------------------------------------------------
procedure TForm1.ErrorMessage(wLogSocket: Word);
var
	dwRes: DWord;
	strbuf: String;
begin
	dwRes := Ad03wGetLastError(wLogSocket);
	case dwRes of
		AD03_ERR_SYSTEM:	strbuf := Format('System error'#10#10'Error code: %08xH', [GetLastError()]);
		AD03_ERR_WRAPDLL: strbuf := 'DLL Load error';
		else              strbuf := Format('AXP-AD03 error'#10#10'Error code: %08xH',[dwRes]);
	end;
	Application.MessageBox(PChar(strbuf), 'AXP-AD03', MB_OK + MB_ICONSTOP);
  Halt(1);
end;

end.
