/*============================================================================
//	Axpad03w.h
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//==========================================================================*/
#pragma once

#include <windows.h>

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;
using namespace System::Threading;
using namespace System::Runtime::InteropServices;

#ifdef MessageBox
#undef MessageBox
#endif

// NX̐錾
__gc public class Axpad03w;

__gc public class Axpad03w
{
private:
	static int mErrWradll = SUCCESS;	// bp[֐G[

public:
	/* Errors */
	static const int	SUCCESS						= 0;	/* Successfully proccessed */
	static const int	ERR_SYSTEM					= 1;	/* Call GetLastError() */
	static const int	ERR_NO_DEVICE				= 2;	/* No card */
	static const int	ERR_IN_USE					= 3;	/* Device is in use */
	static const int	ERR_INVALID_SOCKET			= 4;	/* Invalid logical Socket */
	static const int	ERR_RESOURCE				= 5;	/* Resource exhaustion */
	static const int	ERR_ILLEGAL_FUNCTION_CALL	= 6;	/* Illegal Function Call */
	static const int	ERR_INVALID_ARGUMENT		= 7;	/* Invalid argument */
	static const int	ERR_NUMDATA					= 8;	/* Invalid Number of Data */
	static const int	ERR_INTERNAL				= 9;	/* Internal Error */
	static const int	ERR_WRAPDLL					= -1;	// bp[֐G[

	/* other */
	static const short	SOCKET_AUTO					= -1;	/* I[gT[` */
	static const int	MAX_SOCKETS					= 16;	/* T|[g\Pbg */
	static const int	NUM_CHANNELS				= 2;	/* `l */

	/* Message */
	static const int	WM_BUFF_FULL				= 0;	/* obt@(FIFO)t */
	static const int	WM_CARD_REMOVAL				= 1;	/* J[h */

	/* Sampling Status */
	static const int	STS_SAMPLING				= 0x01;	/* TvO */
	static const int	STS_BUFF_FULL				= 0x02;	/* obt@(FIFO)t */
	static const int	STS_HOLDOFF_ERROR			= 0x04;	/* HOLD OFF G[ */

	/* Resource infomation structure */
	static const int	MAX_MEM						= 9;
	static const int	MAX_IO						= 20;
	static const int	MAX_IRQ						= 7;
	static const int	MAX_DMA						= 7;
	static const int	MAX_RSV						= 3;

	[StructLayout(LayoutKind::Sequential)]
	__gc class Resource
	{
	public:
		Int32 dwNumMemWindows;
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Axpad03w::MAX_MEM)]
		Int32 dwMemBase[];
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Axpad03w::MAX_MEM)]
		Int32 dwMemLength[];
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Axpad03w::MAX_MEM)]
		Int32 dwMemAttrib[];
		Int32 dwNumIOPorts;
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Axpad03w::MAX_IO)]
		Int32 dwIOPortBase[];
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Axpad03w::MAX_IO)]
		Int32 dwIOPortLength[];
		Int32 dwNumIRQs;
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Axpad03w::MAX_IRQ)]
		Int32 dwIRQRegisters[];
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Axpad03w::MAX_IRQ)]
		Int32 dwIRQAttrib[];
		Int32 dwNumDMAs;
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Axpad03w::MAX_DMA)]
		Int32 dwDMALst[];
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Axpad03w::MAX_DMA)]
		Int32 dwDMAAttrib[];
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Axpad03w::MAX_RSV)]
		Int32 dwReserved1[];
	};

	/* Mode structure */
	[StructLayout(LayoutKind::Sequential)]
	__gc class Mode
	{
	public:
		Int32	dwSampleTime;		/* Sampling time */
		Int32	dwTrigMode;			/* Trigger mode */
		Int32	dwTrigSource;		/* Trigger Source */
		Int32	dwTrigSlope;		/* Trigger Slope */
		Int32	dwTrigLevel;		/* Trigger Level */
		Int32	dwTrigPosition;		/* Trigger Position */
		Int32	dwTrigDelay;		/* Trigger Delay time */
		Int32	dwTrigHoldOff;		/* Trigger HoldOff time */
	};

	// API
	[DllImport("axpad03.dll")]
	static bool Ad03GetVersion(int* pdwDllVersion, int* pdwDrvVersion);
	[DllImport("axpad03.dll")]
	static bool Ad03Create(short* pwLogSocket, int hWnd, short uWMBase);
	[DllImport("axpad03.dll")]
	static bool Ad03Close(short wLogSocket);
	[DllImport("axpad03.dll")]
	static bool Ad03GetResource(short wLogSocket, [In][Out] Resource* pres);
	[DllImport("axpad03.dll")]
	static bool Ad03SetMode(short wLogSocket, [In][Out] Mode* pcmode);
	[DllImport("axpad03.dll")]
	static bool Ad03StartSampling(short wLogSocket);
	[DllImport("axpad03.dll")]
	static bool Ad03StopSampling(short wLogSocket);
	[DllImport("axpad03.dll")]
	static bool Ad03GetSamplingStatus(short wLogSocket, int* pdwNumData, int* pdwStatus);
	[DllImport("axpad03.dll")]
	static bool Ad03GetData(short wLogSocket, int cwNumData, short* pwData);
	[DllImport("axpad03.dll")]
	static int  Ad03GetLastError(short wLogSocket);

	/*****************************************************************************/
	/* 	  AXP-AD03 DLL,Vxd̃o[Wԍ擾								 */
	/* 	  pdwDllVersion DLLo[Wԍi[AhX					 */
	/*		  pdwDrvVersion Drvo[Wԍi[AhX					 */
	/* ߂l  true															 */
	/*		  s false														 */
	/*****************************************************************************/
	static bool GetVersion(int* pdwDllVersion, int* pdwDrvVersion)
	{
		try {
			return Ad03GetVersion(pdwDllVersion, pdwDrvVersion);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, S"AXP-AD03 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	/*****************************************************************************/
	/* 	  AXP-AD03̔Cӂ̃foCX̎gp錾								 */
	/* 	  pwLogSocket gpfoCXi[AhX					 */
	/*		  hWnd		荞݂ƂbZ[W𑗂EBhEnh */
	/*        uWMBase   bZ[Wԍ̃x[X                                   */
	/* ߂l  true															 */
	/*		  s false														 */
	/*****************************************************************************/
	static bool Create(short* pwLogSocket, int hWnd, short uWMBase)
	{
		try {
			return Ad03Create(pwLogSocket, hWnd, uWMBase);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, S"AXP-AD03 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	/*****************************************************************************/
	/* 	  AXP-AD03̔Cӂ̃foCX̎gpJ								 */
	/* 	  wLogSocket gpfoCX										 */
	/* ߂l  true															 */
	/*		  s false														 */
	/*****************************************************************************/
	static bool Close(short wLogSocket)
	{
		try {
			return Ad03Close(wLogSocket);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, S"AXP-AD03 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	/*****************************************************************************/
	/* 	  wfoCX̃\[X擾									 */
	/* 	  wLogSocket ׂfoCX											 */
	/*		  pres	   \[Xi[\̂̃AhX					 */
	/* ߂l  true															 */
	/*		  s false														 */
	/*****************************************************************************/
	static bool GetResource(short wLogSocket, [In][Out] Resource* pres)
	{
		try {
			return Ad03GetResource(wLogSocket, pres);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, S"AXP-AD03 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	/*****************************************************************************/
	/* 	  TvO[h̐ݒ											 */
	/* 	  wLogSocket ݒ肷foCX										 */
	/*		  pcmode   [hݒf[^̃AhX								 */
	/* ߂l  true															 */
	/*		  s false														 */
	/*****************************************************************************/
	static bool SetMode(short wLogSocket, [In][Out] Mode* pcmode)
	{
		try {
			return Ad03SetMode(wLogSocket, pcmode);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, S"AXP-AD03 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	/*****************************************************************************/
	/* 	  TvOJn													 */
	/* 	  wLogSocket JnfoCX										 */
	/* ߂l  true															 */
	/*		  s false														 */
	/*****************************************************************************/
	static bool StartSampling(short wLogSocket)
	{
		try {
			return Ad03StartSampling(wLogSocket);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, S"AXP-AD03 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	/*****************************************************************************/
	/* 	  TvO~													 */
	/* 	  wLogSocket ~foCX										 */
	/* ߂l  true															 */
	/*		  s false														 */
	/*****************************************************************************/
	static bool StopSampling(short wLogSocket)
	{
		try {
			return Ad03StopSampling(wLogSocket);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, S"AXP-AD03 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	/*****************************************************************************/
	/* 	  TvOEXe[^X̎擾									 */
	/* 	  wLogSocket	 擾foCX									 */
	/*		  pdwNumData f[^obt@AhX								 */
	/*		  pdwStatus	 Xe[^XAhX										 */
	/* ߂l  true															 */
	/*		  s false														 */
	/*****************************************************************************/
	static bool GetSamplingStatus(short wLogSocket, int* pdwNumData, int* pdwStatus)
	{
		try {
			return Ad03GetSamplingStatus(wLogSocket, pdwNumData, pdwStatus);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, S"AXP-AD03 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	/*****************************************************************************/
	/* 	  TvOς݃f[^̎擾										 */
	/* 	  wLogSocket	擾foCX									 */
	/*		  dwNumData vf[^											 */
	/*		  pwData	f[^obt@ւ̃AhX								 */
	/* ߂l  true															 */
	/*		  s false														 */
	/*****************************************************************************/
	static bool GetData(short wLogSocket, int dwNumData, short* pwData)
	{
		try {
			return Ad03GetData(wLogSocket, dwNumData, pwData);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, S"AXP-AD03 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	/*****************************************************************************/
	/* 	  AXP-AD03̃G[R[h											 */
	/* 	  wLogSocket	G[foCX							 */
	/* ߂l G[R[h														 */
	/*****************************************************************************/
	static int GetLastError(short wLogSocket)
	{
		try {
			if (mErrWradll == ERR_WRAPDLL) {	// bp[֐G[Ȃ
				mErrWradll = SUCCESS;			// NA
				return ERR_WRAPDLL;
			} else {
				return Ad03GetLastError(wLogSocket);
			}
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, S"AXP-AD03 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = SUCCESS;	// bp[֐G[
			return ERR_WRAPDLL;
		}
	}

};
