'****************************************************************************
'*  axpad03w.vb
'*
'*  Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'*
'****************************************************************************
Option Strict Off
Option Explicit On 

Imports System
Imports System.Runtime.InteropServices

Public Class Axpad03w

    Private mErrWradll As Integer = SUCCESS   ' bp[֐G[

    ' Errors
    Public Const SUCCESS As Integer = 0                     ' Successfully proccessed
    Public Const ERR_SYSTEM As Integer = 1                  ' Call GetLastError()
    Public Const ERR_NO_DEVICE As Integer = 2               ' No card
    Public Const ERR_IN_USE As Integer = 3                  ' Device is in use
    Public Const ERR_INVALID_SOCKET As Integer = 4          ' Invalid logical Socket
    Public Const ERR_RESOURCE As Integer = 5                ' Resource exhaustion
    Public Const ERR_ILLEGAL_FUNCTION_CALL As Integer = 6   ' Illegal Function Call
    Public Const ERR_INVALID_ARGUMENT As Integer = 7        ' Invalid argument
    Public Const ERR_NUMDATA As Integer = 8                 ' Invalid Number of Data
    Public Const ERR_INTERNAL As Integer = 9                ' Internal Error
    Public Const ERR_WRAPDLL As Integer = -1                ' bp[֐G[

    ' other
    Public Const SOCKET_AUTO As Short = &HFFFFS             ' I[gT[`
    Public Const MAX_SOCKETS As Integer = 16                ' T|[g\Pbg
    Public Const NUM_CHANNELS As Integer = 2                ' `l

    ' Message
    Public Const WM_BUFF_FULL As Integer = 0                ' obt@(FIFO)t
    Public Const WM_CARD_REMOVAL As Integer = 1             ' J[h

    ' Sampling Status
    Public Const STS_SAMPLING As Integer = &H1              ' TvO
    Public Const STS_BUFF_FULL As Integer = &H2             ' obt@(FIFO)t
    Public Const STS_HOLDOFF_ERROR As Integer = &H4         ' HOLD OFF G[

    ' Resource infomation structure
    Public Const MIN_NUM As Integer = 0
    Public Const MAX_MEM As Integer = 9 - 1    ' MAX_MEM_REGISTERS
    Public Const MAX_IO As Integer = 20 - 1    ' MAX_IO_PORTS
    Public Const MAX_IRQ As Integer = 7 - 1    ' MAX_IRQS
    Public Const MAX_DMA As Integer = 7 - 1    ' MAX_DMA_CHANNELS
    Public Const MAX_RSV As Integer = 3 - 1

    Structure Resource
        Dim dwNumMemWindows As Integer
        <VBFixedArray(MAX_MEM), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_MEM + 1)> Dim dwMemBase() As Integer
        <VBFixedArray(MAX_MEM), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_MEM + 1)> Dim dwMemLength() As Integer
        <VBFixedArray(MAX_MEM), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_MEM + 1)> Dim dwMemAttrib() As Integer
        Dim dwNumIOPorts As Integer
        <VBFixedArray(MAX_IO), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_IO + 1)> Dim dwIOPortBase() As Integer
        <VBFixedArray(MAX_IO), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_IO + 1)> Dim dwIOPortLength() As Integer
        Dim dwNumIRQs As Integer
        <VBFixedArray(MAX_IRQ), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_IRQ + 1)> Dim dwIRQRegisters() As Integer
        <VBFixedArray(MAX_IRQ), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_IRQ + 1)> Dim dwIRQAttrib() As Integer
        Dim dwNumDMAs As Integer
        <VBFixedArray(MAX_DMA), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_DMA + 1)> Dim dwDMALst() As Integer
        <VBFixedArray(MAX_DMA), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_DMA + 1)> Dim dwDMAAttrib() As Integer
        <VBFixedArray(MAX_RSV), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_RSV + 1)> Dim dwReserved1() As Integer
    End Structure

    ' Mode structure
    Structure Mode
        Dim dwSampleTime As Integer    ' Sampling time
        Dim dwTrigMode As Integer      ' Trigger mode
        Dim dwTrigSource As Integer    ' Trigger Source
        Dim dwTrigSlope As Integer     ' Trigger Slope
        Dim dwTrigLevel As Integer     ' Trigger Level
        Dim dwTrigPosition As Integer  ' Trigger Position
        Dim dwTrigDelay As Integer     ' Trigger Delay time
        Dim dwTrigHoldOff As Integer   ' Trigger HoldOff time
    End Structure

    ' API
    <DllImport("axpad03.dll")> _
    Public Shared Function Ad03GetVersion(ByRef pdwDllVersion As Integer, ByRef pdwDrvVersion As Integer) As Boolean
    End Function
    <DllImport("axpad03.dll")> _
    Public Shared Function Ad03Create(ByRef pwLogSocket As Short, ByVal hWnd As Integer, ByVal uWMBase As Short) As Boolean
    End Function
    <DllImport("axpad03.dll")> _
    Public Shared Function Ad03Close(ByVal wLogSocket As Short) As Boolean
    End Function
    <DllImport("axpad03.dll")> _
    Public Shared Function Ad03GetResource(ByVal wLogSocket As Short, ByRef pres As Resource) As Boolean
    End Function
    <DllImport("axpad03.dll")> _
    Public Shared Function Ad03SetMode(ByVal wLogSocket As Short, ByRef pcmode As Mode) As Boolean
    End Function
    <DllImport("axpad03.dll")> _
    Public Shared Function Ad03StartSampling(ByVal wLogSocket As Short) As Boolean
    End Function
    <DllImport("axpad03.dll")> _
    Public Shared Function Ad03StopSampling(ByVal wLogSocket As Short) As Boolean
    End Function
    <DllImport("axpad03.dll")> _
    Public Shared Function Ad03GetSamplingStatus(ByVal wLogSocket As Short, ByRef pcwNumData As Integer, ByRef pdwStatus As Integer) As Boolean
    End Function
    <DllImport("axpad03.dll")> _
    Public Shared Function Ad03GetData(ByVal wLogSocket As Short, ByVal cwNumData As Integer, ByRef pwData As Short) As Boolean
    End Function
    <DllImport("axpad03.dll")> _
    Public Shared Function Ad03GetLastError(ByVal wLogSocket As Short) As Integer
    End Function

    '*****************************************************************************
    '*    AXP-AD03 DLL,Vxd̃o[Wԍ擾                               *
    '*    pdwDllVersion DLLo[Wԍi[AhX                  *
    '*        pdwDrvVersion Drvo[Wԍi[AhX                  *
    '* ߂l  True                                                          *
    '*        s False                                                         *
    '*****************************************************************************
    Public Function GetVersion(ByRef pdwDllVersion As Integer, ByRef pdwDrvVersion As Integer) As Boolean
        Try
            GetVersion = Ad03GetVersion(pdwDllVersion, pdwDrvVersion)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "AXP-AD03 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            GetVersion = False
        End Try
    End Function

    '*****************************************************************************
    '*    AXP-AD03̔Cӂ̃foCX̎gp錾                               *
    '*    pwLogSocket gpfoCXi[AhX                     *
    '*        hWnd      荞݂ƂbZ[W𑗂EBhEnh *
    '*        uWMBase   bZ[Wԍ̃x[X                                   *
    '* ߂l  True                                                          *
    '*        s False                                                         *
    '*****************************************************************************
    Public Function Create(ByRef pwLogSocket As Short, ByVal hWnd As Integer, ByVal uWMBase As Short) As Boolean
        Try
            Create = Ad03Create(pwLogSocket, hWnd, uWMBase)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "AXP-AD03 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            Create = False
        End Try
    End Function

    '*****************************************************************************
    '*    AXP-AD03̔Cӂ̃foCX̎gpJ                               *
    '*    wLogSocket gpfoCX                                        *
    '* ߂l  True                                                          *
    '*        s False                                                         *
    '*****************************************************************************
    Public Function Close(ByVal wLogSocket As Short) As Boolean
        Try
            Close = Ad03Close(wLogSocket)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "AXP-AD03 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            Close = False
        End Try
    End Function

    '*****************************************************************************
    '*    wfoCX̃\[X擾                                   *
    '*    wLogSocket ׂfoCX                                          *
    '*        pres     \[Xi[\                              *
    '* ߂l  True                                                          *
    '*        s False                                                         *
    '*****************************************************************************
    Public Function GetResource(ByVal wLogSocket As Short, ByRef pres As Resource) As Boolean
        Try
            GetResource = Ad03GetResource(wLogSocket, pres)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "AXP-AD03 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            GetResource = False
        End Try
    End Function

    '*****************************************************************************
    '*    TvO[h̐ݒ                                           *
    '*    wLogSocket ݒ肷foCX                                        *
    '*        pcmode   [hݒf[^̃AhX                                *
    '* ߂l  True                                                          *
    '*        s False                                                         *
    '*****************************************************************************
    Public Function SetMode(ByVal wLogSocket As Short, ByRef pcmode As Mode) As Boolean
        Try
            SetMode = Ad03SetMode(wLogSocket, pcmode)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "AXP-AD03 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            SetMode = False
        End Try
    End Function

    '*****************************************************************************
    '*    TvOJn                                                   *
    '*    wLogSocket JnfoCX                                        *
    '* ߂l  True                                                          *
    '*        s False                                                         *
    '*****************************************************************************
    Public Function StartSampling(ByVal wLogSocket As Short) As Boolean
        Try
            StartSampling = Ad03StartSampling(wLogSocket)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "AXP-AD03 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            StartSampling = False
        End Try
    End Function

    '*****************************************************************************
    '*    TvO~                                                   *
    '*    wLogSocket ~foCX                                        *
    '* ߂l  True                                                          *
    '*        s False                                                         *
    '*****************************************************************************
    Public Function StopSampling(ByVal wLogSocket As Short) As Boolean
        Try
            StopSampling = Ad03StopSampling(wLogSocket)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "AXP-AD03 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            StopSampling = False
        End Try
    End Function

    '*****************************************************************************
    '*    TvOEXe[^X̎擾                                     *
    '*    wLogSocket 擾foCX                                        *
    '*        pcwNumData f[^obt@                                        *
    '*        pdwStatus  Xe[^X                                              *
    '* ߂l  True                                                          *
    '*        s False                                                         *
    '*****************************************************************************
    Public Function GetSamplingStatus(ByVal wLogSocket As Short, ByRef pcwNumData As Integer, ByRef pdwStatus As Integer) As Boolean
        Try
            GetSamplingStatus = Ad03GetSamplingStatus(wLogSocket, pcwNumData, pdwStatus)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "AXP-AD03 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            GetSamplingStatus = False
        End Try
    End Function

    '*****************************************************************************
    '*    TvOς݃f[^̎擾                                       *
    '*    wLogSocket 擾foCX                                        *
    '*        cwNumData  vf[^                                            *
    '*        pwData     f[^obt@                                          *
    '* ߂l  True                                                          *
    '*        s False                                                         *
    '*****************************************************************************
    Public Function GetData(ByVal wLogSocket As Short, ByVal cwNumData As Integer, ByRef pwData As Short) As Boolean
        Try
            GetData = Ad03GetData(wLogSocket, cwNumData, pwData)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "AXP-AD03 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            GetData = False
        End Try
    End Function

    '*****************************************************************************
    '*    AXP-AD03̃G[R[h                                             *
    '*    wLogSlot  G[foCX                                 *
    '* ߂l G[R[h                                                       *
    '*****************************************************************************
    Public Function GetLastError(ByVal wLogSocket As Short) As Integer
        Try
            If mErrWradll = ERR_WRAPDLL Then    ' bp[֐G[Ȃ
                mErrWradll = SUCCESS            ' NA
                GetLastError = ERR_WRAPDLL
            Else
                GetLastError = Ad03GetLastError(wLogSocket)
            End If
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "AXP-AD03 Error")
            GetLastError = ERR_WRAPDLL
            mErrWradll = SUCCESS            ' NA
        End Try
    End Function

End Class
