/******************************************************************************/
/*	axpad03s.c																  */
/*																			  */
/*	AXP-AD03															  */
/*																			  */
/*	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.									  */
/*																			  */
/*	Date 1998/07/30															  */
/*																			  */
/*	̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B					  */
/*																			  */
/******************************************************************************/


#define	STRICT
#include	<windows.h>
#include	<tchar.h>

#include "axpad03w.h"


const TCHAR szTitle[] = _T("Sample");
const TCHAR szAD03[] = _T("AXP-AD03");

static void ResultMessage(LPCTSTR lpszbuf);
static void ErrorMessage(WORD wLogSocket);


int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	TCHAR szbuf[1024], szTmp[20];
	DWORD dwDLLVer, dwVxdVer;
	BOOL  bResult;					// 
	WORD  wLogSocket;				// foCXi[
	AD03RESOURCE ri;				// \[X
	AD03MODE md;					// TvO[h
	DWORD cwNumData;
	DWORD dwStatus;
	PWORD pwData;
	LONG  i;

/*---------------------------------------------------------------------------*/
	// axpad03.dll ̎gp錾
	if (Ad03wDllOpen() == FALSE)
	{
		ErrorMessage(AD03_SOCKET_AUTO);
		return 1;			// axpad03.dll ̃[hɎs܂
	}

/*---------------------------------------------------------------------------*/
	// o[Wԍ\
	// AXP-AD03 DLL,VxD̃o[Wԍ擾
	if (Ad03wGetVersion(&dwDLLVer,&dwVxdVer) == FALSE)
	{
		ErrorMessage(AD03_SOCKET_AUTO);
		return 1;
	}

	wsprintf(szbuf, _T("GetVersion\n")
					_T("DLL Version: %08lxh\n")
					_T("Vxd Version: %08lxh"),
					dwDLLVer,
					dwVxdVer);
	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// AXP-AD03̎gp錾
	wLogSocket = AD03_SOCKET_AUTO;		// gp̃foCXT܂B
	bResult = Ad03wCreate(&wLogSocket,	// ꍇA̎̃foCXi[܂B
							NULL,		// e튄荞݂𑗂EBhEnhȂ̂NULL
							0);			// EBhEnhZbg΁Ae튄荞
										// bZ[W܂B
	if (bResult == FALSE)				// foCX܂B
	{
		ErrorMessage(AD03_SOCKET_AUTO);
		return 1;
	}

	wsprintf(szbuf, _T("AXP-AD03 Created\n\n")
					_T("LogSocket: %2d"),
					 wLogSocket);

	ResultMessage(szbuf);
/*---------------------------------------------------------------------------*/
	// \[X擾
	if (Ad03wGetResource(wLogSocket,&ri) == FALSE)
	{
		ErrorMessage(wLogSocket);
		return 1;
	}

	wsprintf(szbuf, _T("Card Name: %s\n")
					_T("NumPorts: %2d\n")
					_T("IO Address: %04xh-%04xh\n")
					_T("IRQ: %2d\n"),
					szAD03,
					ri.dwIOPortLength[0],
					ri.dwIOPortBase[0], ri.dwIOPortBase[0] + ri.dwIOPortLength[0] - 1,
					ri.dwIRQRegisters[0]);

	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// TvO[h̐ݒ
	md.dwSampleTime = 1;		/* Sampling time */
	md.dwTrigMode = 0;			/* Trigger mode */
	md.dwTrigSource = 0;		/* Trigger Source */
	md.dwTrigSlope = 0;			/* Trigger Slope */
	md.dwTrigLevel = 0;			/* Trigger Level */
	md.dwTrigPosition = 20;		/* Trigger Position */
	md.dwTrigDelay = 0;			/* Trigger Delay time */
	md.dwTrigHoldOff = 0;		/* Trigger HoldOff time */

	if (Ad03wSetMode(wLogSocket,&md) == FALSE)
	{
		ErrorMessage(wLogSocket);
		return 1;
	}

	wsprintf(szbuf, _T("AXP-AD03 Sampling Mode\n")
					_T("TvO^C=%ld\n")
					_T("gK[h=%ld\n")
					_T("gK\[X=%ld\n")
					_T("gKX[v=%ld\n")
					_T("gKx=%ld\n")
					_T("gK|WV=%ld\n")
					_T("gKfBC=%ld\n")
					_T("gKgnkcnee=%ld\n"),
					md.dwSampleTime,md.dwTrigMode,md.dwTrigSource,md.dwTrigSlope,
					md.dwTrigLevel,md.dwTrigPosition,md.dwTrigDelay,md.dwTrigHoldOff);

	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// TvOJn
	if (Ad03wStartSampling(wLogSocket) == FALSE)
	{
		ErrorMessage(wLogSocket);
		return 1;
	}

	ResultMessage(_T("AXP-AD03 Sampling Started"));

/*---------------------------------------------------------------------------*/
	// TvOEXe[^X̎擾
	if (Ad03wGetSamplingStatus(wLogSocket,&cwNumData,&dwStatus) == FALSE)
	{
		ErrorMessage(wLogSocket);
		return 1;
	}

	wsprintf(szbuf, _T("TvOEXe[^X擾\n")
					_T("f[^=%ld\n")
					_T("Xe[^X=%ld"),
					cwNumData,dwStatus);

	ResultMessage(szbuf);

/*---------------------------------------------------------------------------*/
	// TvOς݃f[^̎擾
	if (cwNumData)
	{
		pwData = (PWORD)malloc(cwNumData * sizeof(WORD));
		memset(pwData,0,cwNumData * sizeof(WORD));

		if (Ad03wGetData(wLogSocket,cwNumData,pwData) == FALSE)
		{
			ErrorMessage(wLogSocket);
			return 1;
		}

		wsprintf(szbuf, _T("TvOς݃f[^擾\n"));
		for (i = 0; i < (LONG)cwNumData && lstrlen(szbuf) < sizeof(szbuf) - sizeof(szTmp) ; i++)
		{
			wsprintf(szTmp, _T("%ld:%lxh  "), i, pwData[i]);
			strcat(szbuf, szTmp);
			if ((i + 1) % 4 == 0)	// 4 Ŋ؂
				strcat(szbuf, _T("\n"));
		}
		ResultMessage(szbuf);
		free(pwData);
	}

/*---------------------------------------------------------------------------*/
	// TvO~(ʏ͎gp܂)
	if (Ad03wStopSampling(wLogSocket) == FALSE)
	{
		ErrorMessage(wLogSocket);
		return 1;
	}

	ResultMessage(_T("AXP-AD03 Sampling Stopped"));
/*---------------------------------------------------------------------------*/
	// AXP-AD03̎gpJ
	if (Ad03wClose(wLogSocket) == FALSE)
	{
		ErrorMessage(wLogSocket);
		return 1;
	}
	ResultMessage(_T("AXP-AD03 Closed"));

/*---------------------------------------------------------------------------*/
	// axpad03.dll ̎gpJ
	if (Ad03wDllClose() == FALSE)
	{
		MessageBox(NULL, _T("DLL Unload error"), szTitle, MB_OK | MB_ICONSTOP);
		return 1;			// axpad03.dll ̃A[hɎs܂B
	}
	return 0;
}

// ʂ\
static void ResultMessage(LPCTSTR lpszbuf)
{
	MessageBox(NULL, lpszbuf, szTitle, MB_OK | MB_ICONINFORMATION);
}

// G[bZ[W\
static void ErrorMessage(WORD wLogSocket)
{
	DWORD dwRes = Ad03wGetLastError(wLogSocket);
	TCHAR szbuf[50];

	switch (dwRes)
	{
		case AD03_ERR_WRAPDLL:
			wsprintf(szbuf, _T("DLL Load error"));
			break;

		default:
			wsprintf(szbuf, _T("AXP-AD03 error\n\n")
							_T("Error code: %08lxh"),
							dwRes);
			break;
	}

	MessageBox(NULL, szbuf, szTitle, MB_OK | MB_ICONSTOP);
}
